#if HAVE_CONFIG_H
#  include <config.h>
#endif /* HAVE_CONFIG_H */

#include "ProjectWizardTypePage.h"

#include "ProjectWizardNewAirportPage.h"
#include "ProjectWizardNewProjectPage.h"
#include "ProjectWizardOpenProjectPage.h"

IMPLEMENT_CLASS(ProjectWizardTypePage,wxWizardPage);

ProjectWizardTypePage::ProjectWizardTypePage(wxWizard* parent,
                              ProjectWizardNewAirportPage* newAirportPage,
                              ProjectWizardNewProjectPage* newProjectPage,
                              ProjectWizardOpenProjectPage* openProjectPage,
                              const wxBitmap& bitmap,
                              const wxChar *resource):
              wxWizardPage(parent,bitmap,resource),
              _newAirportPage(newAirportPage),
              _newProjectPage(newProjectPage),
              _openProjectPage(openProjectPage)
{
        wxBoxSizer* topSizer=new wxBoxSizer(wxVERTICAL);
        
        wxArrayString choices;
        choices.Add(wxT("New project for new airport"));
        choices.Add(wxT("New project for existing airport"));
        choices.Add(wxT("Open existing project"));
        _radioBox=new wxRadioBox(this, wxID_ANY,wxT("Operation"),
                                 wxDefaultPosition,wxDefaultSize,
                                 choices);
        //_radioBox->Enable(0,false);
        //_radioBox->Enable(2,false);
        _radioBox->SetSelection(1);
        
        topSizer->Add(_radioBox,wxSizerFlags(1).Expand());
        
        SetSizer(topSizer);
        
        topSizer->SetSizeHints(this);
        
        Fit();
}

ProjectWizardTypePage::~ProjectWizardTypePage() {
}

wxWizardPage* ProjectWizardTypePage::GetNext() const {
        int sel=_radioBox->GetSelection();
        
        switch (sel) {
        case New_Airport:
                return _newAirportPage;
        case New_Project:
                return _newProjectPage;
        case Open_Project:
                return _openProjectPage;
        default:
                return NULL;
        }
}

wxWizardPage* ProjectWizardTypePage::GetPrev() const {
        return NULL;
}

