#ifndef MapPassInstance_h
#define MapPassInstance_h

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif

#include "MapPass.h"
/**
 * \brief A MapPassInstance represents an instance of a MapPass in a MapEditor.
 *
 * It contains information about the state of a pass in a specific editor.
 * A pass can be enabled or disabled. When it is disabled, it is not painted.
 */

class MapPassInstance {
public:
        MapPassInstance(const MapPass& pass):
                _pass(pass),_enabled(true) {}
        
        const wxString& GetName() const { return _pass.GetName(); }
        
        const MapPass& GetPass() const { return _pass; }
        
        const bool IsEnabled() const {
                return _enabled;
        }
        
        void Enable() { _enabled=true; }
        void Disable() { _enabled=false; }
public:
        const MapPass& _pass;
        bool _enabled;
};

#endif
