#include "MapProjectionDescriptor.h"

IMPLEMENT_ABSTRACT_CLASS(MapProjectionDescriptor,wxObject);

#include "MapProjection.h"

MapProjectionDescriptorMap MapProjectionDescriptor::_descriptorMap;

MapProjectionDescriptor::MapProjectionDescriptor(const wxString& name,
                                                 const wxString& description,
                                                 wxClassInfo* classInfo):
        _name(name),
        _description(description),
        _classInfo(classInfo)
{
}

MapProjectionDescriptor::~MapProjectionDescriptor() {
}

void MapProjectionDescriptor::RegisterDescriptor(MapProjectionDescriptor* desc) {
        wxASSERT(_descriptorMap.find(desc->GetName())==_descriptorMap.end());
        _descriptorMap[desc->GetName()]=desc;
}

void MapProjectionDescriptor::UnregisterDescriptor(MapProjectionDescriptor* desc) {
        MapProjectionDescriptorMap::iterator it;
        
        it=_descriptorMap.find(desc->GetName());
        
        wxASSERT(it->second==desc);
        
        _descriptorMap.erase(it);
}

MapProjection* MapProjectionDescriptor::CreateInstance() {
        MapProjection* proj=wxDynamicCast(_classInfo->CreateObject(),MapProjection);
        proj->SetDescriptor(this);
        return proj;
}

MapProjection* MapProjectionDescriptor::CreateInstanceForName(const wxString& name) {
        MapProjectionDescriptorMap::iterator it=_descriptorMap.find(name);
        if (it==_descriptorMap.end()) {
                return NULL;
	}
        return it->second->CreateInstance();
}
