#ifndef MapProjectionDescriptor_h
#define MapProjectionDescriptor_h

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif

class MapProjectionDescriptor;
class MapProjection;

WX_DECLARE_STRING_HASH_MAP(MapProjectionDescriptor*,MapProjectionDescriptorMap);

class MapProjectionDescriptor: public wxObject {
        
        DECLARE_ABSTRACT_CLASS(MapProjectionDescriptor)
        
public:
	MapProjectionDescriptor(const wxString& name,
                                const wxString& description,
                                wxClassInfo* classInfo);
        virtual ~MapProjectionDescriptor();
        
        const wxString& GetName() const { return _name; }
        const wxString& GetDescription() const { return _description; }
        
        virtual MapProjection* CreateInstance();
        
        static void RegisterDescriptor(MapProjectionDescriptor* desc);
        static void UnregisterDescriptor(MapProjectionDescriptor* desc);
        
        static MapProjection* CreateInstanceForName(const wxString& name);
        
        static const MapProjectionDescriptorMap& GetDescriptors() {
                return _descriptorMap;
        }
protected:
        wxString _name;
        wxString _description;
        wxClassInfo* _classInfo;
        static MapProjectionDescriptorMap _descriptorMap;
};

#endif

