#ifndef ModifyMode_h
#define ModifyMode_h

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif

#include <Map/Mode.h>
#include <Math/point3d.h>

class MapDraggable;

class ModifyMode : public Mode {
        
        DECLARE_CLASS(ModifyMode)
        
public:
        ModifyMode(wxString defaultDesc):
                _currentDraggable(NULL),
                _defaultDescription(defaultDesc)
        {
        }

        void OnLeftButtonDown(wxMouseEvent& evt);

        void OnMouseMotion(wxMouseEvent& evt);

        void OnLeftButtonUp(wxMouseEvent& evt);

        virtual void Leave(bool force=false);
private:
        DECLARE_EVENT_TABLE()
        
        MapDraggable *_currentDraggable;
        wxString _defaultDescription;
        bool _wasDragged;
};

#endif


