#ifndef PavementInsertionMode_h
#define PavementInsertionMode_h

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif

#include <Airport/Airport.h>
#include <Airport/PavementMapObject.h>
#include <Map/Mode.h>
#include <Math/point3d.h>


class PavementInsertionMode : public Mode {
        
        DECLARE_CLASS(PavementInsertionMode)
        
public:
        typedef enum {
                InsertionMode_InsertRunway,
                InsertionMode_InsertTaxiway
        } InsertionMode;
        
	PavementInsertionMode(Airport::SmartRef airport, InsertionMode mode);
        virtual ~PavementInsertionMode();
        
        /* Leave this mode */
	virtual void Leave(bool force=false);
        
        /* Get a string for the status bar. */
	virtual wxString GetStatus();
        
        void OnLeftDown(wxMouseEvent& evt);
        void OnPaint(wxPaintEvent& dc);
        void OnMouseMotion(wxMouseEvent& evt);
        void OnLeftUp(wxMouseEvent& evt);
private:
        DECLARE_EVENT_TABLE()
        
        Airport::SmartRef _airport;
        InsertionMode _mode;
        
        bool _active;
        size_t _pointCount;
        Point3D _centerEnds[2];
        Point3D _geoCenter;
        PavementMapObject::SmartRef _pavementObject;
};

#endif


